/* migstat07_sas.zip: ID_2007.sas 
   ex: http://www.gesis.org/missy/fileadmin/missy/daten/mikrodaten_tools/Rekodierung_doppelter_Identifikatoren/ID_2007.sas
*/


OPTIONS NOFMTERR; RUN;   /* ohne Formate */

/* Arbeitsverzeichnis in '<...>' eintragen; z. B. c:\temp */
* libname mzjahr '<Arbeitsverzeichnis'>;


/* ----------------------------------------------------------------------------

0. Datenvorbereitung

Programm zur Rekodierung doppelter Identifikatoren im Scientific Use File 
des Mikrozensus 2007: Nr. des Haushalts im Auswahlbezirk (EF4) und Nummer 
der Person im Haushalt (EF5).
[...]
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Quelle http://www.gesis.org/missy/home/auswahl-datensatz/mikrozensus-2007/
       --- Arbeitshilfen: Rekodierung doppelter Identifikatoren --- 
URL: http://www.gesis.org/missy/fileadmin/missy/daten/mikrodaten_tools/
     Rekodierung_doppelter_Identifikatoren/ID_2007.sas
 
--- geringfuegig modifiziert fuer die Typisierung des Migrationsstatus ---
---------------------------------------------------------------------------  */


/* Ausgangsdaten MZ 2007 mit Variablenauswahl einlesen
Zur Abgrenzung eines Haushalts erforderliche Variablen 
    siehe http://www.gesis.org/missy/studie/arbeitshilfen/datenaufbereitung-analyse/identifikatoren-fuer-haushalte/
  EF3   Nr. des Auswahlbezirks
  EF4   Nr. des Haushalts im Auswahlbezirk
  EF12  Berichtsquartal (bei der Verwendung von Jahresueberhaengen) 
  EF5   Nr. der Person im Haushalt (systemfrei)
  
Variablen fuer Erstellung des Migrationsstatus: EF30-EF952
*/


data mzjahr.mz2007r 
	(KEEP = EF1   EF3   EF4   EF5   EF8   EF9   EF12  EF30  EF31  EF44  
	        EF46  EF47  EF49  EF50  EF51  EF52  EF53  EF54  EF55  EF366
 		EF367 EF368 EF369 EF370 EF371 EF372 EF373 EF374 EF952 
	        EF4R EF5R ID_ORG);
	retain  EF1   EF3   EF4   EF5   EF8   EF9   EF12  EF30  EF31  EF44  
	        EF46  EF47  EF49  EF50  EF51  EF52  EF53  EF54  EF55  EF366
 		EF367 EF368 EF369 EF370 EF371 EF372 EF373 EF374 EF952 
	        EF4R EF5R ID_ORG;
   set mzjahr.mz2007; 

	* Satznummer Ausgangsfile VOR Rekodierungen;
	ID_ORG = _n_ ;
	Label ID_ORG ="[ID_ORG] Lfd. Satznummer Ausgangsfile mz2007.sas7bdat";
	
	EF4R = EF4;
	Label EF4R  = "Nr. des Haushalts im Auswahlbezirk rekodiert (systemfrei)";
	
	EF5R = EF5;
	Label EF5R = "Nr. der Person im Haushalt rekodiert (systemfrei)";

	if (EF3=  106 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R= 6;
	if (EF3=  230 & EF4= 6 & EF5= 1 & EF8= 8 & EF9= 8 & EF12=1 & EF31=2) then EF4R= 8;
	if (EF3=  337 & EF4= 2 & EF5= 2 & EF8= 4 & EF9= 1 & EF12=2 & EF31=2) then EF4R=11;
	if (EF3=  337 & EF4= 4 & EF5= 6 & EF8= 4 & EF9=1  & EF12=2 & EF31=2) then EF4R=12;
	if (EF3=  337 & EF4= 6 & EF5= 3 & EF8= 4 & EF9=1  & EF12=2 & EF31=2) then EF4R=13;
	if (EF3=  337 & EF4= 9 & EF5= 5 & EF8= 4 & EF9=1  & EF12=2 & EF31=2) then EF4R=14;
	if (EF3=  475 & EF4= 3 & EF5= 2 & EF8= 9 & EF9= 6 & EF12=1 & EF31=2) then EF4R=11;
	if (EF3=  683 & EF4= 5 & EF5= 2 & EF8= 3 & EF9= 6 & EF12=1 & EF31=2) then EF4R=10;
	if (EF3=  814 & EF4= 3 & EF5= 5 & EF8= 5 & EF9= 1 & EF12=1 & EF31=2) then EF4R=11;
	if (EF3=  814 & EF4=10 & EF5= 7 & EF8= 5 & EF9= 1 & EF12=1 & EF31=2) then EF4R=12;
	if (EF3= 1059 & EF4= 4 & EF5= 2 & EF8= 4 & EF9= 8 & EF12=3 & EF31=2) then EF4R=10;
	if (EF3= 1074 & EF4= 5 & EF5= 2 & EF8= 2 & EF9= 6 & EF12=1 & EF31=2) then EF4R=14;
	if (EF3= 1074 & EF4= 3 & EF5= 8 & EF8= 2 & EF9= 6 & EF12=1 & EF31=2) then EF4R=15;
	if (EF3= 1074 & EF4= 8 & EF5= 9 & EF8= 2 & EF9= 6 & EF12=1 & EF31=2) then EF4R=16;
	if (EF3= 1141 & EF4= 5 & EF5= 4 & EF8= 3 & EF9= 2 & EF12=4 & EF31=2) then EF4R= 8;
	if (EF3= 1141 & EF4= 6 & EF5= 3 & EF8= 3 & EF9= 2 & EF12=4 & EF31=2) then EF4R= 9;
	if (EF3= 1209 & EF4= 1 & EF5= 3 & EF8= 6 & EF9= 3 & EF12=1 & EF31=2) then EF4R= 8;
	if (EF3= 1209 & EF4= 3 & EF5= 2 & EF8= 6 & EF9= 3 & EF12=1 & EF31=2) then EF4R= 9;
	if (EF3= 1209 & EF4= 3 & EF5= 2 & EF8= 7 & EF9= 8 & EF12=1 & EF31=2) then EF4R=10;
	if (EF3= 1209 & EF4= 3 & EF5= 2 & EF8= 8 & EF9= 9 & EF12=1 & EF31=2) then EF4R=11;
	if (EF3= 2035 & EF4= 1 & EF5= 2 & EF8= 1 & EF9= 5 & EF12=4 & EF31=2) then EF4R= 6; 
	if (EF3= 2035 & EF4= 2 & EF5= 3 & EF8= 1 & EF9= 5 & EF12=4 & EF31=2) then EF4R= 7;
	if (EF3= 2233 & EF4= 1 & EF5= 3 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 5;
	if (EF3= 2233 & EF4= 2 & EF5= 5 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 6;
	if (EF3= 2233 & EF4= 3 & EF5= 2 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R= 3;
	if (EF3= 2233 & EF4= 3 & EF5= 2 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 7;
	if (EF3= 2810 & EF4= 1 & EF5= 3 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R= 4;
	if (EF3= 2810 & EF4= 2 & EF5= 2 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R= 5;
	if (EF3= 2903 & EF4= 1 & EF5= 5 & EF8= 6 & EF9= 4 & EF12=2 & EF31=2) then EF4R= 8;
	if (EF3= 2903 & EF4= 2 & EF5= 2 & EF8= 6 & EF9= 4 & EF12=2 & EF31=2) then EF4R= 9;
	if (EF3= 2903 & EF4= 5 & EF5= 3 & EF8= 6 & EF9= 4 & EF12=2 & EF31=2) then EF4R=10;
	if (EF3= 2903 & EF4= 6 & EF5= 6 & EF8= 6 & EF9= 4 & EF12=2 & EF31=2) then EF4R=11;
	if (EF3= 3255 & EF4= 4 & EF5= 1 & EF8= 5 & EF9= 8 & EF12=4 & EF31=2) then EF4R= 8;
	if (EF3= 3715 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 2 & EF12=4 & EF31=2) then EF4R= 3;
	if (EF3= 3773 & EF4=11 & EF5= 1 & EF8= 1 & EF9=24 & EF12=4 & EF31=2) then EF4R=25;
	if (EF3= 5310 & EF4= 6 & EF5= 1 & EF8= 5 & EF9= 6 & EF12=4 & EF31=2) then EF4R=10;
	if (EF3= 6099 & EF4= 2 & EF5= 2 & EF8= 1 & EF9= 2 & EF12=3 & EF31=2) then EF4R= 4;
	if (EF3= 6099 & EF4= 1 & EF5= 3 & EF8= 1 & EF9= 3 & EF12=3 & EF31=2) then EF4R= 5;
	if (EF3= 6099 & EF4= 2 & EF5= 2 & EF8= 1 & EF9= 3 & EF12=3 & EF31=2) then EF4R= 6;
	if (EF3= 7018 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 3 & EF12=1 & EF31=2) then EF4R= 4;
	if (EF3= 7018 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 4 & EF12=1 & EF31=2) then EF4R= 5;
	if (EF3= 7083 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R= 3;
	if (EF3= 7083 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 3 & EF12=2 & EF31=2) then EF4R= 4;
	if (EF3= 7083 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 4 & EF12=3 & EF31=2) then EF4R= 5;
	if (EF3= 7083 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 6 & EF12=3 & EF31=2) then EF4R= 6;
	if (EF3= 7316 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 3;
	if (EF3= 7316 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 3 & EF12=2 & EF31=2) then EF4R= 4;
	if (EF3= 7316 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 4 & EF12=3 & EF31=2) then EF4R= 5;
	if (EF3= 7316 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 5 & EF12=2 & EF31=2) then EF4R= 6;
	if (EF3= 7820 & EF4= 1 & EF5= 4 & EF8= 4 & EF9= 1 & EF12=1 & EF31=2) then EF4R= 8;
	if (EF3= 7820 & EF4= 2 & EF5= 3 & EF8= 4 & EF9= 1 & EF12=1 & EF31=2) then EF4R= 9;
	if (EF3= 8040 & EF4= 5 & EF5= 4 & EF8= 1 & EF9= 3 & EF12=4 & EF31=2) then EF4R=11;
	if (EF3= 8040 & EF4= 7 & EF5= 3 & EF8= 1 & EF9= 3 & EF12=4 & EF31=2) then EF4R=12;
	if (EF3= 8160 & EF4= 5 & EF5= 1 & EF8= 7 & EF9=10 & EF12=1 & EF31=2) then EF4R=10;
	if (EF3= 8576 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 2 & EF12=1 & EF31=2) then EF4R= 6;
	if (EF3= 8839 & EF4= 7 & EF5= 2 & EF8= 6 & EF9= 5 & EF12=4 & EF31=2) then EF4R=10;
	if (EF3= 8839 & EF4= 1 & EF5= 3 & EF8= 6 & EF9= 5 & EF12=4 & EF31=2) then EF4R=11;
	if (EF3= 8839 & EF4= 3 & EF5= 6 & EF8= 6 & EF9= 5 & EF12=4 & EF31=2) then EF4R=12;
	if (EF3= 8949 & EF4= 4 & EF5= 1 & EF8= 3 & EF9= 1 & EF12=4 & EF31=1) then EF4R= 5;
	if (EF3= 8949 & EF4= 4 & EF5= 2 & EF8= 3 & EF9= 1 & EF12=4 & EF31=1) then EF4R= 5;
	if (EF3= 8949 & EF4= 4 & EF5= 3 & EF8= 3 & EF9= 1 & EF12=4 & EF31=1) then EF4R= 5;
	if (EF3= 9254 & EF4= 5 & EF5= 4 & EF8= 1 & EF9= 1 & EF12=1 & EF31=2) then EF4R=13;
	if (EF3= 9254 & EF4= 6 & EF5= 7 & EF8= 1 & EF9= 1 & EF12=1 & EF31=2) then EF4R=14;
	if (EF3= 9254 & EF4=11 & EF5= 6 & EF8= 1 & EF9= 1 & EF12=1 & EF31=2) then EF4R=15;
	if (EF3=11378 & EF4= 1 & EF5= 7 & EF8= 2 & EF9= 1 & EF12=1 & EF31=2) then EF4R= 9;
	if (EF3=11378 & EF4= 3 & EF5= 3 & EF8= 2 & EF9= 1 & EF12=1 & EF31=2) then EF4R=10;
	if (EF3=11378 & EF4= 6 & EF5= 6 & EF8= 2 & EF9= 1 & EF12=1 & EF31=2) then EF4R=11;
	if (EF3=12609 & EF4= 1 & EF5= 1 & EF8= 2 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 8;
	if (EF3=12609 & EF4= 6 & EF5= 5 & EF8= 2 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 9;
	if (EF3=14040 & EF4= 3 & EF5= 3 & EF8= 1 & EF9= 1 & EF12=1 & EF31=2) then EF4R= 6;
	if (EF3=14283 & EF4= 1 & EF5= 2 & EF8= 1 & EF9= 3 & EF12=4 & EF31=2) then EF4R= 7;
	if (EF3=20009 & EF4= 2 & EF5= 2 & EF8= 5 & EF9= 7 & EF12=1 & EF31=2) then EF4R= 8;
	if (EF3=20009 & EF4= 5 & EF5= 3 & EF8= 5 & EF9= 7 & EF12=1 & EF31=2) then EF4R= 9;
	if (EF3=20261 & EF4= 3 & EF5= 2 & EF8= 2 & EF9= 2 & EF12=1 & EF31=2) then EF4R=12;
	if (EF3=20261 & EF4= 1 & EF5= 4 & EF8= 2 & EF9= 2 & EF12=1 & EF31=2) then EF4R=13;
	if (EF3=20261 & EF4= 5 & EF5=10 & EF8= 2 & EF9= 2 & EF12=1 & EF31=2) then EF4R=14;
	if (EF3=20261 & EF4= 6 & EF5= 9 & EF8= 2 & EF9= 2 & EF12=1 & EF31=2) then EF4R=15;
	if (EF3=20261 & EF4= 8 & EF5= 7 & EF8= 2 & EF9= 2 & EF12=1 & EF31=2) then EF4R=16;
	if (EF3=20326 & EF4= 1 & EF5= 2 & EF8= 2 & EF9= 4 & EF12=2 & EF31=2) then EF4R=17;
	if (EF3=20326 & EF4= 2 & EF5=14 & EF8= 2 & EF9= 4 & EF12=2 & EF31=2) then EF4R=18;
	if (EF3=20326 & EF4= 4 & EF5= 5 & EF8= 2 & EF9= 4 & EF12=2 & EF31=2) then EF4R=19;
	if (EF3=20326 & EF4= 5 & EF5=15 & EF8= 2 & EF9= 4 & EF12=2 & EF31=2) then EF4R=20;
	if (EF3=20326 & EF4= 7 & EF5= 9 & EF8= 2 & EF9= 4 & EF12=2 & EF31=2) then EF4R=21;
	if (EF3=20326 & EF4= 8 & EF5= 8 & EF8= 2 & EF9= 4 & EF12=2 & EF31=2) then EF4R=22;
	if (EF3=20326 & EF4=10 & EF5=12 & EF8= 2 & EF9= 4 & EF12=2 & EF31=2) then EF4R=23;
	if (EF3=20326 & EF4=13 & EF5= 6 & EF8= 2 & EF9= 4 & EF12=2 & EF31=2) then EF4R=24;
	if (EF3=20789 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 2 & EF12=4 & EF31=2) then EF4R= 2;
	if (EF3=20789 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 3 & EF12=4 & EF31=2) then EF4R= 3;
	if (EF3=20789 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 4 & EF12=4 & EF31=2) then EF4R= 4;
	if (EF3=21211 & EF4= 6 & EF5= 3 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R= 8;
	if (EF3=21381 & EF4= 1 & EF5= 3 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 6;
	if (EF3=21381 & EF4= 2 & EF5= 2 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 7;
	if (EF3=21690 & EF4= 2 & EF5= 3 & EF8= 1 & EF9= 2 & EF12=4 & EF31=2) then EF4R= 3;
	if (EF3=22039 & EF4= 4 & EF5= 2 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 9;
	if (EF3=22260 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=3 & EF31=2) then EF4R= 4;
	if (EF3=22771 & EF4= 1 & EF5= 2 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R=26;
	if (EF3=22792 & EF4= 2 & EF5= 3 & EF8= 1 & EF9= 1 & EF12=3 & EF31=2) then EF4R=13;
	if (EF3=23598 & EF4= 1 & EF5= 7 & EF8= 3 & EF9= 4 & EF12=4 & EF31=2) then EF4R= 9;
	if (EF3=23598 & EF4= 4 & EF5= 2 & EF8= 3 & EF9= 4 & EF12=4 & EF31=2) then EF4R=10;
	if (EF3=23598 & EF4= 5 & EF5= 3 & EF8= 3 & EF9= 4 & EF12=4 & EF31=2) then EF4R=11;
	if (EF3=23840 & EF4= 6 & EF5= 2 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=26;
	if (EF3=23840 & EF4= 1 & EF5=12 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=27;
	if (EF3=23840 & EF4= 3 & EF5= 9 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=28;
	if (EF3=23840 & EF4=17 & EF5= 7 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=29;
	if (EF3=23840 & EF4= 4 & EF5= 4 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=30;
	if (EF3=24110 & EF4= 5 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=3 & EF31=1) then EF4R=10;
	if (EF3=24110 & EF4= 5 & EF5= 2 & EF8= 1 & EF9= 1 & EF12=3 & EF31=1) then EF4R=10;
	if (EF3=24110 & EF4= 5 & EF5= 3 & EF8= 1 & EF9= 1 & EF12=3 & EF31=1) then EF4R=10;
	if (EF3=24842 & EF4= 1 & EF5= 9 & EF8= 1 & EF9= 1 & EF12=3 & EF31=2) then EF4R= 7;
	if (EF3=25270 & EF4= 9 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R=18;
	if (EF3=25785 & EF4= 1 & EF5= 3 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=11;
	if (EF3=25785 & EF4= 2 & EF5= 2 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=12;
	if (EF3=26183 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R= 8;
	if (EF3=28454 & EF4= 1 & EF5= 1 & EF8= 2 & EF9= 1 & EF12=3 & EF31=1) then EF4R= 9;
	if (EF3=28454 & EF4= 1 & EF5= 2 & EF8= 2 & EF9= 1 & EF12=3 & EF31=1) then EF4R= 9;
	if (EF3=28454 & EF4= 1 & EF5= 3 & EF8= 2 & EF9= 1 & EF12=3 & EF31=1) then EF4R= 9;
	if (EF3=28595 & EF4= 5 & EF5= 3 & EF8= 3 & EF9= 2 & EF12=4 & EF31=2) then EF4R=12;
	if (EF3=28595 & EF4= 2 & EF5= 5 & EF8= 3 & EF9= 2 & EF12=4 & EF31=2) then EF4R=13;
	if (EF3=28595 & EF4= 7 & EF5= 2 & EF8= 3 & EF9= 2 & EF12=4 & EF31=2) then EF4R=14;
	if (EF3=28595 & EF4= 9 & EF5= 8 & EF8= 3 & EF9= 2 & EF12=4 & EF31=2) then EF4R=15;
	if (EF3=28595 & EF4=10 & EF5= 6 & EF8= 3 & EF9= 2 & EF12=4 & EF31=2) then EF4R=16;
	if (EF3=29164 & EF4= 3 & EF5= 2 & EF8= 8 & EF9= 8 & EF12=1 & EF31=2) then EF4R=10;
	if (EF3=29513 & EF4= 1 & EF5= 3 & EF8= 2 & EF9= 2 & EF12=2 & EF31=2) then EF4R=16;
	if (EF3=29513 & EF4= 2 & EF5= 5 & EF8= 2 & EF9= 2 & EF12=2 & EF31=2) then EF4R=17;
	if (EF3=29513 & EF4= 5 & EF5= 1 & EF8= 2 & EF9= 2 & EF12=2 & EF31=2) then EF4R=18;
	if (EF3=29513 & EF4=10 & EF5= 2 & EF8= 2 & EF9= 2 & EF12=2 & EF31=2) then EF4R=19;
	if (EF3=29529 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 6;
	if (EF3=29866 & EF4= 2 & EF5= 1 & EF8= 2 & EF9= 2 & EF12=4 & EF31=2) then EF4R= 9;
	if (EF3=29866 & EF4= 5 & EF5= 4 & EF8= 2 & EF9= 2 & EF12=4 & EF31=2) then EF4R=10;
	if (EF3=30138 & EF4= 5 & EF5= 7 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=11;
	if (EF3=30303 & EF4= 1 & EF5= 3 & EF8= 1 & EF9= 2 & EF12=1 & EF31=2) then EF4R= 6;
	if (EF3=30376 & EF4= 2 & EF5= 2 & EF8= 1 & EF9= 1 & EF12=3 & EF31=2) then EF4R= 9;
	if (EF3=31579 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R=10;
	if (EF3=31579 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 3 & EF12=2 & EF31=2) then EF4R= 3;
	if (EF3=31579 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 4 & EF12=2 & EF31=2) then EF4R= 4;
	if (EF3=31579 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 5 & EF12=2 & EF31=2) then EF4R= 5;
	if (EF3=31579 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 7 & EF12=2 & EF31=2) then EF4R= 7;
	if (EF3=31579 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 8 & EF12=2 & EF31=2) then EF4R= 8;
	if (EF3=31579 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 9 & EF12=2 & EF31=2) then EF4R= 9;
	if (EF3=31664 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R=14;
	if (EF3=31664 & EF4= 3 & EF5= 8 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R=15;
	if (EF3=31664 & EF4= 4 & EF5= 7 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R=16;
	if (EF3=31664 & EF4= 9 & EF5=13 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R=17;
	if (EF3=32551 & EF4= 7 & EF5= 2 & EF8= 4 & EF9= 1 & EF12=2 & EF31=2) then EF4R=10;
	if (EF3=32551 & EF4= 2 & EF5= 9 & EF8= 4 & EF9= 1 & EF12=2 & EF31=2) then EF4R=11;
	if (EF3=32551 & EF4= 5 & EF5= 4 & EF8= 4 & EF9= 1 & EF12=2 & EF31=2) then EF4R=12;
	if (EF3=33407 & EF4= 4 & EF5= 2 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R= 6;
	if (EF3=34558 & EF4= 1 & EF5= 1 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R= 2;
	if (EF3=34956 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R=40;
	if (EF3=34956 & EF4= 3 & EF5= 4 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R=41;
	if (EF3=34956 & EF4= 4 & EF5= 6 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R=42;
	if (EF3=34958 & EF4=46 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=62;
	if (EF3=34958 & EF4=28 & EF5= 2 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=63;
	if (EF3=34958 & EF4= 7 & EF5= 5 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=64;
	if (EF3=34958 & EF4=14 & EF5=11 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=65;
	if (EF3=34958 & EF4=22 & EF5=13 & EF8= 1 & EF9= 1 & EF12=2 & EF31=2) then EF4R=66;
	if (EF3=35206 & EF4= 2 & EF5= 4 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 7;
	if (EF3=35578 & EF4= 9 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=4 & EF31=2) then EF4R=12;
	if (EF3=35581 & EF4=10 & EF5= 4 & EF8=10 & EF9= 7 & EF12=3 & EF31=2) then EF4R=18;
	if (EF3=36444 & EF4= 8 & EF5= 3 & EF8=13 & EF9= 8 & EF12=2 & EF31=2) then EF4R=17;
	if (EF3=36462 & EF4= 4 & EF5=15 & EF8= 3 & EF9= 4 & EF12=2 & EF31=2) then EF4R=19;
	if (EF3=36654 & EF4=11 & EF5= 1 & EF8= 1 & EF9= 3 & EF12=3 & EF31=1) then EF4R=13;
	if (EF3=36654 & EF4= 2 & EF5= 6 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=14;
	if (EF3=36654 & EF4= 3 & EF5=12 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=15;
	if (EF3=36654 & EF4= 4 & EF5= 1 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=16;
	if (EF3=36654 & EF4= 5 & EF5=11 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=17;
	if (EF3=36654 & EF4= 6 & EF5= 9 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=18;
	if (EF3=36654 & EF4= 7 & EF5= 2 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=19;
	if (EF3=36654 & EF4= 8 & EF5= 5 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=20;
	if (EF3=36654 & EF4= 9 & EF5= 8 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=21;
	if (EF3=36654 & EF4=11 & EF5= 3 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=22;
	if (EF3=36654 & EF4=12 & EF5=13 & EF8= 2 & EF9= 2 & EF12=3 & EF31=2) then EF4R=23;
	if (EF3=36860 & EF4= 1 & EF5= 2 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 8;
	if (EF3=38422 & EF4= 2 & EF5= 2 & EF8= 3 & EF9= 1 & EF12=2 & EF31=2) then EF4R= 6;
	if (EF3=38422 & EF4= 1 & EF5= 4 & EF8= 3 & EF9= 1 & EF12=2 & EF31=2) then EF4R= 7;
	if (EF3=38439 & EF4= 4 & EF5= 2 & EF8= 1 & EF9= 4 & EF12=2 & EF31=2) then EF4R= 6;
	if (EF3=39081 & EF4= 1 & EF5= 1 & EF8= 2 & EF9= 3 & EF12=2 & EF31=2) then EF4R= 6;
	if (EF3=39081 & EF4= 2 & EF5= 4 & EF8= 2 & EF9= 3 & EF12=2 & EF31=2) then EF4R= 7;
	if (EF3=39081 & EF4= 3 & EF5= 6 & EF8= 2 & EF9= 3 & EF12=2 & EF31=2) then EF4R= 8;
	if (EF3=39081 & EF4= 5 & EF5= 3 & EF8= 2 & EF9= 3 & EF12=2 & EF31=2) then EF4R= 9;
	if (EF3=39081 & EF4= 1 & EF5= 1 & EF8= 3 & EF9= 2 & EF12=2 & EF31=2) then EF4R=10;
	if (EF3=41864 & EF4= 3 & EF5= 1 & EF8= 1 & EF9= 2 & EF12=1 & EF31=2) then EF4R=22;
	if (EF3=41864 & EF4= 8 & EF5= 7 & EF8= 1 & EF9= 2 & EF12=1 & EF31=2) then EF4R=23;
	if (EF3=41864 & EF4=13 & EF5=10 & EF8= 1 & EF9= 2 & EF12=1 & EF31=2) then EF4R=24;
	if (EF3=41864 & EF4=14 & EF5= 4 & EF8= 1 & EF9= 2 & EF12=1 & EF31=2) then EF4R=25;
	if (EF3=41864 & EF4= 9 & EF5= 8 & EF8= 1 & EF9= 2 & EF12=1 & EF31=2) then EF4R=26;
	if (EF3=41920 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 4 & EF12=4 & EF31=2) then EF4R= 5;
	if (EF3=41920 & EF4= 4 & EF5= 2 & EF8= 1 & EF9= 4 & EF12=4 & EF31=2) then EF4R= 6;
	if (EF3=43626 & EF4= 1 & EF5= 2 & EF8= 3 & EF9= 4 & EF12=1 & EF31=2) then EF4R= 7;
	if (EF3=43634 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 2 & EF12=1 & EF31=2) then EF4R= 5;
	if (EF3=43803 & EF4= 2 & EF5= 1 & EF8= 1 & EF9= 1 & EF12=3 & EF31=2) then EF4R= 5;
	if (EF3=43803 & EF4= 4 & EF5= 4 & EF8= 1 & EF9= 1 & EF12=3 & EF31=2) then EF4R= 6;
	if (EF3=43907 & EF4= 1 & EF5= 1 & EF8= 1 & EF9= 2 & EF12=2 & EF31=2) then EF4R= 4;
	if (EF3=45021 & EF4= 7 & EF5= 2 & EF8= 1 & EF9= 2 & EF12=3 & EF31=2) then EF4R=12;
	if (EF3=45021 & EF4= 1 & EF5=10 & EF8= 1 & EF9= 2 & EF12=3 & EF31=2) then EF4R=13;
	if (EF3=45021 & EF4= 2 & EF5= 8 & EF8= 1 & EF9= 2 & EF12=3 & EF31=2) then EF4R=14;
	if (EF3=45021 & EF4= 5 & EF5= 5 & EF8= 1 & EF9= 2 & EF12=3 & EF31=2) then EF4R=15;
run ; 

/* Zwischensortierung  */
proc sort data=mzjahr.mz2007r; 
    by EF1 EF3 EF4R EF5 ;
run;


data mzjahr.mz2007r ;
   set mzjahr.mz2007r; 
	* Satznummer nach Rekodierungen;
	IDX = _n_ ;
	if (IDX=1299  & EF3=106  & EF4R=6 & EF5=1) then EF5R = 1;
	if (IDX=1300  & EF3=106  & EF4R=6 & EF5=1) then EF5R = 2;
	if (IDX=15667 & EF3=1355 & EF4R=2 & EF5=1) then EF5R = 1;
	if (IDX=15668 & EF3=1355 & EF4R=2 & EF5=1) then EF5R = 2;
	if (IDX=18369 & EF3=1775 & EF4R=1 & EF5=1) then EF5R = 1;
	if (IDX=18370 & EF3=1775 & EF4R=1 & EF5=1) then EF5R = 2;
	if (IDX=18371 & EF3=1775 & EF4R=1 & EF5=1) then EF5R = 3;
	if (IDX=18372 & EF3=1775 & EF4R=2 & EF5=4) then EF5R = 1;
	if (IDX=18373 & EF3=1775 & EF4R=2 & EF5=4) then EF5R = 2;
	if (IDX=18375 & EF3=1775 & EF4R=4 & EF5=3) then EF5R = 1;
	if (IDX=18376 & EF3=1775 & EF4R=4 & EF5=3) then EF5R = 2;
	if (IDX=18377 & EF3=1775 & EF4R=4 & EF5=3) then EF5R = 3;
	if (IDX=56051 & EF3=4878 & EF4R=1 & EF5=1) then EF5R = 1;
	if (IDX=56052 & EF3=4878 & EF4R=1 & EF5=1) then EF5R = 2;
	if (IDX=56053 & EF3=4878 & EF4R=1 & EF5=1) then EF5R = 3;
	if (IDX=56054 & EF3=4878 & EF4R=1 & EF5=1) then EF5R = 4;
	if (IDX=56055 & EF3=4878 & EF4R=1 & EF5=1) then EF5R = 5;
	if (IDX=56056 & EF3=4878 & EF4R=1 & EF5=1) then EF5R = 6;
run;

proc sort data=mzjahr.mz2007r; 
    by ID_ORG;
run;


data mzjahr.mz2007r
	(drop=IDX EF4R EF5R);
	retain EF1 EF3 EF4 EF5 EF12 ;
	set mzjahr.mz2007r; /* ( rename=( EF4=EF4_ORG EF5=EF5_ORG EF4=EF4R EF5=EF5R ) ); */

	ef4_org = ef4;
	ef5_org = ef5;
	ef4 = ef4r;
	ef5 = ef5r;

Label EF1      = '[EF1] Bundesland';
Label EF3      = '[EF3] Nr. des Auswahlbezirks (systemfrei)';
Label EF4      = '[EF4] Nr. des Haushalts im Auswahlbezirk (systemfrei) - plausibilisiert ex EF4R';
Label EF5      = '[EF5] Nr. der Person im Haushalt (EF5a) - plausibilisiert ex EF5r' ;
label EF12     = '[EF12] Berichtsquartal';
Label ID_ORG   = '[ID_ORG] Lfd. Satznummer Ausgangsfile mz2006';
Label EF4_ORG  = '[EF4_ORG] Nr. des Haushalts im Auswahlbezirk (systemfrei) - Orginalvariable';
Label EF5_ORG  = '[EF5_ORG] Nr. der Person im Haushalt (EF5) - Originalvariable';
run;

